31e74821545b0b10ff12d7f8ba6a1dbe94fb76a2
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/sh
2 # Filename:      grml-bootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 ################################################################################
8 # http://www.debian.org/releases/stable/i386/index.html.en
9
10 set -e # exit on any error
11
12 # variables {{{
13 PN="$(basename $0)"
14 VERSION='0.18'
15 MNTPOINT="/mnt/debootstrap.$$"
16
17 # inside the chroot system locales might not be available, so use minimum:
18 export LANG=C
19 export LC_ALL=C
20
21 # make sure interactive mode is only executed when
22 # using an empty configuration file or option --interactive
23 INTERACTIVE=''
24 # }}}
25
26 # source core functions {{{
27 . /etc/grml/lsb-functions
28 . /etc/grml/script-functions
29 # }}}
30
31 # help text {{{
32 usage() {
33   echo "$PN - wrapper around debootstrap for installing Debian
34
35 Usage: $PN [options]
36
37   -h|--help                   Print this usage information and exit.
38   -v|--version                Show summary of options and exit.
39
40   -c|--config <configfile>    Use specified configuration file,
41                               defaults to /etc/debootstrap/config
42   --hostname <hostname>       Hostname of Debian system
43   -i|--iso <mnt>              Mountpoint where a Debian ISO is mounted to,
44                               for use instead of fetching packages from a mirror
45   -m|--mirror <URL>           Mirror which should be used for apt-get/aptitude.
46   -p|--mntpoint <mnt>         Mountpoint used for mounting the target system.
47   -r|--release <release>      Release of new Debian system (default: stable)
48   -t|--target <target>        Target partition (/dev/...) or directory.
49
50   --boot_append <appendline>  Add specified appendline to kernel whilst booting
51   --groot <device>            Root device for usage in grub, corresponds with
52                               \$TARGET in grub syntax, like hd0,0 for /dev/sda1
53   --grub <device>             Target for grub installation. Use grub syntax
54                               for specifying, like hd0 for /dev/sda
55   --interactive               Use interactive mode (frontend)
56   --password <pwd>            Use specified password as password for user root.
57
58 Send bugreports to the grml-team: bugs@grml.org || http://grml.org/bugs/
59 "
60 }
61
62 if [ "$1" = '-h' ] || [ "$1" = '-help' ] ; then
63    usage
64    echo 'Please notice that this script requires root permissions!'
65    exit 0
66 fi
67 # }}}
68
69 # make sure we have what we need {{{
70 check4progs debootstrap dialog || exit 1
71 check4root || exit 1
72 # }}}
73
74 # source configuration file {{{
75 if [ -r /etc/debootstrap/config ] ; then
76    if [ -n "$CONFIGFILE" ] ; then
77       if ! . "$CONFIGFILE" ; then
78          eerror "Error reading config file $CONFIGFILE" ; eend 1 ; exit 1
79       fi
80    else
81       . /etc/debootstrap/config
82    fi
83 fi
84 # }}}
85
86 # cmdline handling {{{
87
88 while [ "$#" -gt "0" ] ; do
89     case $1 in
90         -c|--config)
91             shift
92             CONFIGFILE=$1
93             ;;
94         --grub)
95             shift
96             GRUB=$1
97             ;;
98         --groot)
99             shift
100             GROOT=$1
101             ;;
102         -h|--help)
103             usage ; eend 0
104             eend 0
105             exit 0
106             ;;
107         --hostname)
108             shift
109             HOSTNAME=$1
110             ;;
111         --interactive)
112             INTERACTIVE=1
113             ;;
114         -i|--iso)
115             shift
116             [ -n "$MIRROR" ] && unset MIRROR
117             ISO=$1
118             ;;
119         -m|--mirror)
120             shift
121             MIRROR=$1
122             CHROOTMIRROR=$1
123             ;;
124         -p|--mntpoint)
125             shift
126             MNTPOINT=$1
127             ;;
128         --password)
129             shift
130             ROOTPASSWORD=$1
131             ;;
132         -r|--release)
133             shift
134             RELEASE=$1
135             ;;
136         -t|--target)
137             shift
138             TARGET=$1
139             ;;
140         -v|--version)
141             einfo "$PN - version $VERSION"
142             einfo "Send bug reports to bugs@grml.org or http://grml.org/bugs/"
143             eend 0
144             exit 0
145             ;;
146         *)
147             eerror "Syntax error."
148             usage ; eend 1
149             exit 1
150             ;;
151     esac
152     shift
153 done
154 # }}}
155
156 # welcome screen {{{
157 welcome_dialog()
158 {
159    dialog --title "$PN" --yesno "Welcome to the interactive configuration of ${PN}.
160 Do you want to continue installing Debian using this frontend?" 0 0
161 }
162 # }}}
163
164 # ask for target {{{
165 prompt_for_target()
166 {
167   AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
168                sed 's/*//' | \
169                grep -v 'Extended$' | \
170                gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
171
172   [ -n "$AVAILABLE_PARTITIONS" ] || echo "FIXME: no partitions available?"
173   PARTITION_LIST=$(for i in $(echo $AVAILABLE_PARTITIONS) ; do
174                        echo "$i $(vol_id --type $i 2>/dev/null || echo [no_filesystem_yet])"
175                    done)
176
177   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
178          --menu "Please select the target partition:" 0 0 0 \
179          $PARTITION_LIST)
180 }
181 # }}}
182
183 # ask for bootmanager {{{
184 prompt_for_bootmanager()
185 {
186   ADDITIONAL_PARAMS=""
187   for device in sda hda; do
188     if [ /dev/$device != ${TARGET%[0-9]} ]; then
189       grep -q $device /proc/partitions && \
190       ADDITIONAL_PARAMS=:$device:"install bootmanager grub into MBR of /dev/${device}"
191     fi
192   done
193   ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
194
195   OIFS="$IFS"; IFS=:
196
197   if echo $TARGET | grep -q "/dev/md" ; then
198      MBRPART="all disks of Software RAID $TARGET"
199   else
200      MBRPART="MBR of ${TARGET%[0-9]}"
201   fi
202
203   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
204           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
205             mbr       "install bootmanager into $MBRPART" \
206             partition "install bootmanager into partition $TARGET" \
207             nowhere   "do not install bootmanager at all" \
208           ${ADDITIONAL_PARAMS})
209   [ $? -eq 0 ] || bailout 3
210   IFS="$OIFS"
211
212   case "$GETMBR" in
213     mbr)
214       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
215       if echo $TARGET | grep -q "*md*" ; then
216          BOOT_PARTITION="${TARGET}"
217       else
218          BOOT_PARTITION="${TARGET%[0-9]}"
219       fi
220       ;;
221     partition)
222       BOOT_PARTITION="$TARGET"
223       ;;
224     hda)
225       BOOT_PARTITION="/dev/hda"
226       ;;
227     sda)
228       BOOT_PARTITION="/dev/sda"
229       ;;
230     nowhere)
231       BOOT_PARTITION=''
232       ;;
233   esac
234 }
235 # }}}
236
237 # ask for Debian release {{{
238 prompt_for_release()
239 {
240   RELEASE="$(dialog --stdout --title "${PN}" --default-item etch --menu \
241             "Please enter the Debian release you would like to use for installation:" \
242             0 50 3 \
243             etch   Debian/stable \
244             lenny  Debian/testing \
245             sid    Debian/unstable)"
246 }
247 # }}}
248
249 # ask for hostname {{{
250 prompt_for_hostname()
251 {
252   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
253             "Please enter the hostname you would like to use for installation:" \
254             0 0 grml)"
255 }
256 # }}}
257
258 # ask for Debian mirror {{{
259 prompt_for_mirror()
260 {
261   MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
262             "Please enter Debian mirror you would like to use for installing packages." \
263             0 0 http://ftp.de.debian.org/debian)"
264 }
265 # }}}
266
267 # get grub's syntax for /dev/ice {{{
268 # usage example: 'grubdevice /dev/sda2' returns 'hd0,1'
269 grubdevice() {
270   if [ -z "$1" ] ; then
271      echo "Usage: grubdevice <device>">&2
272      return 1
273   fi
274
275   device="$1"
276   device_map=/boot/grub/device.map
277
278   # create device.map
279   if ! [ -f "$device_map" ] ; then
280      echo 'quit' | grub --device-map="$device_map" 1>/dev/null 2>&1
281   fi
282
283   # based on code from d-i's trunk/packages/arch/i386/grub-installer/grub-installer:
284   tmp_disk=`echo "$device" | sed -e 's%\([sh]d[a-z]\)[0-9]*$%\1%' \
285                     -e 's%\(fd[0-9]*\)$%\1%' \
286                     -e 's%/part[0-9]*$%/disc%' \
287                     -e 's%\(c[0-7]d[0-9]*\).*$%\1%'`
288   tmp_part=`echo "$device" | sed -e 's%.*/[sh]d[a-z]\([0-9]*\)$%\1%' \
289                     -e 's%.*/fd[0-9]*$%%' \
290                     -e 's%.*/floppy/[0-9]*$%%' \
291                     -e 's%.*/\(disc\|part\([0-9]*\)\)$%\2%' \
292                     -e 's%.*c[0-7]d[0-9]*p*%%'`
293   tmp_drive=$(grep -v '^#' $device_map | grep "$tmp_disk *$" | sed 's%.*\([hf]d[0-9][a-g0-9,]*\).*%\1%')
294
295   case $1 in
296      /dev/[sh]d[a-z]) # we expect something like 'hd0'
297         echo "$tmp_drive"
298         ;;
299       *) # we expect something like 'hd0,0'
300         echo "$tmp_drive" | sed "s%$%,`expr $tmp_part - 1`%" # FIXME => md0
301         ;;
302   esac
303 }
304 # }}}
305
306 # software raid setup {{{
307 config_swraid_setup()
308 {
309 TMPFILE=$(mktemp)
310 RAIDLEVEL=$(dialog --stdout --title "$PN" --default-item raid1 \
311                    --menu "Which RAID level do you want to use?" 0 0 0 \
312                      raid1 "Software RAID level 1" \
313                      raid5 "Software RAID level 5")
314 [ $? -eq 0 ] || bailout 20
315
316 MD_LIST=$(for i in $(seq 0 9) ; do
317             awk '{print $4}' /proc/partitions | grep -q md$i || \
318             echo "/dev/md$i /dev/md$i"
319           done)
320
321 TARGET=$(dialog --stdout --title "$PN" --default-item /dev/md0 \
322 --menu "Which device do you want to use for ${RAIDLEVEL}?
323
324 Notice: activated devices will not be listed for security reasons. Anyway, please make sure the selected device is not in use already!" 0 0 0 \
325 $MD_LIST)
326 [ $? -eq 0 ] || bailout 20
327
328 AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
329              sed 's/*//' | \
330              grep -v 'Extended$' | \
331              gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
332 [ -n "$AVAILABLE_PARTITIONS" ] || echo "FIXME: no partitions available?"
333 PARTITION_LIST=$(for i in $(echo $AVAILABLE_PARTITIONS) ; do
334                      echo "$i $(vol_id --type $i 2>/dev/null || echo [no_filesystem_yet]) off"
335                  done)
336
337 dialog --title "$PN" \
338        --single-quoted \
339        --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
340        $PARTITION_LIST 2>$TMPFILE
341 RETVAL=$?
342 SELECTED_PARTITIONS="$(cat $TMPFILE)"
343
344 NUM_PARTITIONS=0
345 for i in $(cat $TMPFILE) ; do
346    NUM_PARTITIONS=$((${NUM_PARTITIONS}+1))
347 done
348
349 ERRORFILE=$(mktemp)
350 set +e
351 # TODO: better error handling?
352 yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
353       --raid-devices="${NUM_PARTITIONS}" ${SELECTED_PARTITIONS} 1>/dev/null 2>$ERRORFILE
354 RC=$?
355 set -e
356
357 if [ "$RC" = 0 ] ; then
358    dialog --title "$PN" --msgbox \
359    "Creating $TARGET was successful." 0 0
360    rm -f "$TMPFILE" "$ERRORFILE"
361 else
362    dialog --title "$PN" --msgbox \
363    "There was an error setting up $TARGET:
364
365 $(cat $ERRORFILE)
366
367 Exiting." 0 0
368    rm -f "$TMPFILE" "$ERRORFILE"
369    exit 1
370 fi
371
372 }
373
374 prompt_for_swraid()
375 {
376 if dialog --stdout --title "$PN" \
377           --defaultno --yesno "Do you want to configure Software RAID?
378
379 Please notice that currently only RAID levels 1 and 5 are supported by ${PN}. Configuration will take place using mdadm." 0 0 ; then
380   config_swraid_setup
381 fi
382 }
383 # }}}
384
385 # make sure the user is aware of the used configuration {{{
386 checkconfiguration()
387 {
388 if [ -n "$AUTOINSTALL" ] ; then
389    if checkforrun ; then
390       eerror "Exiting as requested" ; eend 0
391       exit 1
392    fi
393 elif [ -n "$INTERACTIVE" ] ; then
394
395    INFOTEXT="Please recheck configuration before execution:
396    "
397    [ -n "$TARGET" ]  && INFOTEXT="$INFOTEXT
398    Target:          $TARGET"
399    [ -n "$GRUB" ]    && INFOTEXT="$INFOTEXT
400    Install grub:    $GRUB"
401    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
402    Using release:   $RELEASE"
403    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
404    Using mirror:    $MIRROR"
405
406    INFOTEXT="$INFOTEXT
407
408 Is this ok for you? Notice: selecting 'No' will exit ${PN}."
409
410    dialog --title "$PN" --no-collapse \
411           --yesno "$INFOTEXT" 0 0
412
413 else # if not running automatic installation display configuration and prompt for execution:
414    einfo "$PN - Please recheck configuration before execution:"
415    echo
416    echo "   Target:          $TARGET"
417       case "$MNTPOINT" in "$TARGET") ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
418       [ -n "$GRUB" ]    && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
419       [ -n "$RELEASE" ] && echo "   Using release:   $RELEASE"
420       [ -n "$MIRROR" ]  && echo "   Using mirror:    $MIRROR"
421       [ -n "$ISO" ]     && echo "   Using iso:       $ISO"
422       case "$MNTPOINT" in "$TARGET") ;; *) echo "   Important! Continuing will delete all data from ${TARGET}!" ;; esac
423       echo
424    einfon "Is this ok for you? [y/N] "
425    read a
426    if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
427       eerror "Exiting as requested." ; eend 1
428       exit 1
429    fi
430 fi
431 }
432 # }}}
433
434 # interactive mode {{{
435 interactive_mode()
436 {
437   welcome_dialog
438
439   prompt_for_swraid
440
441   # do not prompt for partition dialog if swraid has been configured already
442   [ -n "$TARGET" ] || prompt_for_target
443
444   prompt_for_bootmanager
445
446   prompt_for_release
447
448   prompt_for_hostname
449
450   # use first disk of sw-raid for grub by default, install grub on
451   # all involved disks later on
452   if echo "$TARGET" | grep -q '/dev/md' ; then
453      if [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
454         # use hdX and not hdX,Y for $GRUB
455         TMPDEVICE=$(echo ${SELECTED_PARTITIONS} | awk '{print $1}') # use first disk only
456         GRUB="$(grubdevice ${TMPDEVICE%%[0-9]})" # like: hd0
457         GROOT="$(grubdevice ${TMPDEVICE})"       # like: hd0,0
458         echo "debug: GRUB = $GRUB - GROOT = $GROOT" >/tmp/debug # FIXME
459      fi
460   else
461      [ -n "$BOOT_PARTITION" ] && GRUB="$(grubdevice $BOOT_PARTITION)"
462      [ -n "$TARGET" ]         && GROOT="$(grubdevice $TARGET)"
463   fi
464
465   prompt_for_mirror
466
467   checkconfiguration
468 }
469
470 # run interactive mode if we didn't get the according configuration yet
471 if [ -z "$TARGET" -o -n "$INTERACTIVE" ] ; then
472    # only target might be unset, so make sure the INTERACTIVE flag is set as well
473    INTERACTIVE=1
474    interactive_mode
475 fi
476 # }}}
477
478 # finally make sure at least $TARGET is set [the partition for the new system] {{{
479 if [ -n "$TARGET" ] ; then
480    SHORT_TARGET="${TARGET##*/}"
481 else
482    eerror "Please adjust /etc/debootstrap/config or..."
483    eerror "... use the interactive version for configuration before running ${0}" ; eend 1
484    exit 1
485 fi
486 # }}}
487
488 # stages setup {{{
489 if [ -z "$STAGES" ] ; then
490    STAGES="/var/cache/grml-debootstrap/stages_${SHORT_TARGET}"
491    [ -d "$STAGES" ] || mkdir -p "$STAGES"
492 fi
493
494 if [ -r "$STAGES"/grml-debootstrap ] ; then
495    if grep -q done $STAGES/grml-debootstrap ; then
496       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
497       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}" ; eend 1
498    fi
499 fi
500 # }}}
501
502 # partition handling {{{
503 PARTITION=''
504 DIRECTORY=''
505
506 case $TARGET in
507   /dev/*)
508     PARTITION=1
509     ;;
510   *)
511     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
512     DIRECTORY=1
513     MNTPOINT="$TARGET"
514     MKFS=''
515     TUNE2FS=''
516     FSCK=''
517     GRUB=''
518     GROOT=''
519     ;;
520 esac
521 # }}}
522
523 # architecture setup {{{
524 if [ -n "$ARCH" ] ; then
525    ARCHCMD="--arch $ARCH"
526    ARCHINFO=" (${ARCH})"
527 else
528    ARCH="$(dpkg --print-architecture)"
529    ARCHCMD="--arch $ARCH"
530    ARCHINFO=" (${ARCH})"
531 fi
532 # }}}
533
534 # make sure we have the right syntax when using an iso image {{{
535 if [ -n "$ISO" ] ; then
536    case $ISO in
537       file*) # do nothing
538       ;;
539       *)
540       ISO=file:$1
541       ;;
542    esac
543 fi
544 ISODIR=${ISO##file:}
545 ISODIR=${ISODIR%%/}
546 # }}}
547
548 # provide variables to chroot system {{{
549 CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
550 touch $CHROOT_VARIABLES
551 chmod 600 $CHROOT_VARIABLES # make sure nobody except root can read it
552 [ -n "$ARCH" ]   && echo "ARCH=$ARCH"     >  $CHROOT_VARIABLES
553 [ -n "$GRUB" ]   && echo "GRUB=$GRUB"     >> $CHROOT_VARIABLES
554 [ -n "$GROOT" ]  && echo "GROOT=$GROOT"   >> $CHROOT_VARIABLES
555 [ -n "$TARGET" ] && echo "TARGET=$TARGET" >> $CHROOT_VARIABLES
556 [ -n "$ISO" ]    && echo "ISO=$ISO"       >> $CHROOT_VARIABLES
557 [ -n "$ISODIR" ] && echo "ISODIR=$ISO"    >> $CHROOT_VARIABLES
558 [ -n "$MIRROR" ] && echo "MIRROR=$MIRROR" >> $CHROOT_VARIABLES
559 [ -n "$MIRROR" ] && echo "CHROOTMIRROR=$MIRROR" >> $CHROOT_VARIABLES
560 [ -n "$ROOTPASSWORD" ] && echo "ROOTPASSWORD=$ROOTPASSWORD" >> $CHROOT_VARIABLES
561 # }}}
562
563 # helper functions {{{
564 # we want to exit smoothly and clean:
565 bailout(){
566   # make sure $TARGET is not mounted when exiting grml-debootstrap
567   if [ -n "$MNTPOINT" ] ; then
568      if grep -q $MNTPOINT /proc/mounts ; then
569         # make sure nothing is left inside chroot so we can unmount it
570         [ -x "$MNTPOINT"/etc/init.d/ssh   ] && "$MNTPOINT"/etc/init.d/ssh stop
571         [ -x "$MNTPOINT"/etc/init.d/mdadm ] && "$MNTPOINT"/etc/init.d/mdadm stop
572         # ugly, but make sure we really don't leav anything
573         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /sys  1>/dev/null 2>&1
574         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a    1>/dev/null 2>&1
575         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
576         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
577         [ -d "$MNTPOINT/$ISODIR" ]    && umount "$MNTPOINT/$ISODIR" 1>/dev/null 2>&1
578         einfo "Unmounting $MNTPOINT"   ; umount "$MNTPOINT" ; eend $?
579
580         if [ -n "$STAGES" ] ; then
581            echo -n "Removing stages directory ${STAGES}: "
582            rm -rf "$STAGES" && echo done
583         fi
584
585         # remove directory only if we used the default with process id inside the name
586         if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
587            einfo "Removing directory ${MNTPOINT}" ; rmdir $MNTPOINT ; eend $?
588         fi
589      fi
590   fi
591
592   [ -n "$1" ] && EXIT="$1" || EXIT="1"
593   [ -n "$3" ] && einfo "Notice: just remove $STAGES/$3 to reexecute the stage"
594
595   exit "$EXIT"
596 }
597 trap bailout HUP INT QUIT TERM
598
599 # we want to execute all the functions only once, simple check for it:
600 stage() {
601   if [ -n "$2" ] ; then
602      echo "$2" > "${STAGES}/${1}"
603      return 0
604   elif grep -q done "${STAGES}/${1}" 2>/dev/null ; then
605      ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
606      eindent
607        ewarn "To reexecute it clean up the according directory inside $STAGES" ; eend 0
608      eoutdent
609      return 1
610   fi
611 }
612 # }}}
613
614 # user should recheck his configuration {{{
615 # support full automatic installation:
616 checkforrun() {
617    dialog --timeout 10 --title "$PN" \
618           --yesno "Do you want to stop at this stage?
619
620 Notice: you are running ${PN} in non-interactive mode.
621 ${PN} will install Debian ${RELEASE} on ${TARGET}.
622 Last chance to quit. Timeout of 10 seconds running....
623
624 Do you want to stop now?" 0 0 2>/dev/null
625 }
626
627 # create filesystem {{{
628 mkfs() {
629   if [ -n "$MKFS" ] ; then
630      einfo "Running $MKFS on $TARGET"
631      $MKFS $TARGET
632      eend $?
633   fi
634 }
635 # }}}
636
637 # modify filesystem settings {{{
638 tunefs() {
639   if [ -n "$TUNE2FS" ] ; then
640      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
641      $TUNE2FS $TARGET
642      eend $?
643   fi
644 }
645 # }}}
646
647 # mount the new partition or if it's a directory do nothing at all {{{
648 mount_target() {
649   if [ -n "$DIRECTORY" ] ; then
650      einfo "Running grml-debootstrap on a directory, nothing to mount."
651   else
652      if grep -q $TARGET /proc/mounts ; then
653         eerror "$TARGET already mounted, exiting."
654      else
655        [ -d "$MNTPOINT" ] || mkdir -p "$MNTPOINT"
656        einfo "Mounting $TARGET to $MNTPOINT"
657        mount -o rw,suid,dev $TARGET $MNTPOINT
658        eend $?
659      fi
660   fi
661   if [ -n "$ISODIR" ] ; then
662      einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
663      mkdir -p "$MNTPOINT/$ISODIR"
664      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
665      eend $?
666   fi
667 }
668 # }}}
669
670 # install main chroot {{{
671 debootstrap_system() {
672   if ! grep -q $MNTPOINT /proc/mounts ; then
673      mount_target
674   fi
675   if grep -q $MNTPOINT /proc/mounts ; then
676      einfo "Running $DEBOOTSTRAP for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
677      [ -n "$MIRROR" ] && $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $MIRROR || \
678      $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $ISO
679      eend $?
680   else
681      eerror "Error: $MNTPOINT not mounted, can not continue."
682      eend 1
683   fi
684 }
685 # }}}
686
687 # prepare chroot via chroot-script {{{
688 preparechroot() {
689   einfo "Preparing chroot system"
690   cp $CONFFILES/chroot-script $MNTPOINT/bin/chroot-script
691   chmod 755 $MNTPOINT/bin/chroot-script
692   mkdir $MNTPOINT/etc/debootstrap/
693
694   # make sure we have our files for later use via chroot-script
695   cp /etc/debootstrap/config    $MNTPOINT/etc/debootstrap/
696   # make sure we adjust the configuration variables accordingly:
697   sed -i "s/RELEASE=.*/RELEASE=\"$RELEASE\"/" $MNTPOINT/etc/debootstrap/config
698   sed -i "s/TARGET=.*/TARGET=\"$TARGET\"/"    $MNTPOINT/etc/debootstrap/config
699   sed -i "s/GRUB=.*/GRUB=\"$GRUB\"/"          $MNTPOINT/etc/debootstrap/config
700   sed -i "s/GROOT=.*/GROOT=\"$GROOT\"/"       $MNTPOINT/etc/debootstrap/config
701
702   cp /etc/debootstrap/packages  $MNTPOINT/etc/debootstrap/packages
703
704   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
705   cp $CHROOT_VARIABLES          $MNTPOINT/etc/debootstrap/variables
706
707   cp -a /etc/debootstrap/extrapackages/ $MNTPOINT/etc/debootstrap/
708
709   # make sure we can access network [relevant for cdebootstrap]
710   [ -f "$MNTPOINT/etc/resolv.conf" ] || cp /etc/resolv.conf $MNTPOINT/etc/resolv.conf
711
712   # provide system's /etc/hosts to the target:
713   if ! [ -f "$MNTPOINT/etc/hosts" ] ; then
714      cp /etc/hosts $MNTPOINT/etc/hosts
715      sed -i "s/127.0.0.1 .*/127.0.0.1       localhost  $HOSTNAME/" /etc/hosts
716   fi
717
718   # setup default locales
719   [ -n "$LOCALES" ] && cp /etc/debootstrap/locale.gen  $MNTPOINT/etc/locale.gen
720
721   # MAKEDEV is just a forking bomb crap, let's do it on our own instead :)
722   ( cd $MNTPOINT/dev && tar zxf /etc/debootstrap/devices.tar.gz )
723
724   # copy any existing existing files to chroot
725   [ -d /etc/debootstrap/boot  ] && cp -a /etc/debootstrap/boot/*  $MNTPOINT/boot/
726   [ -d /etc/debootstrap/etc   ] && cp -a /etc/debootstrap/etc/*   $MNTPOINT/etc/
727   [ -d /etc/debootstrap/share ] && cp -a /etc/debootstrap/share/* $MNTPOINT/share/
728   [ -d /etc/debootstrap/usr   ] && cp -a /etc/debootstrap/usr/*   $MNTPOINT/usr/
729   [ -d /etc/debootstrap/var   ] && cp -a /etc/debootstrap/var/*   $MNTPOINT/var/
730
731   # copy local network setup to chroot
732   if [ -r /etc/network/interfaces -a ! -r "${MNTPOINT}"/etc/network/interfaces ] ; then
733      [ -d $MNTPOINT/etc/network ] || mkdir $MNTPOINT/etc/network
734      cp /etc/network/interfaces $MNTPOINT/etc/network/interfaces
735   fi
736
737   eend 0
738 }
739 # }}}
740
741 # execute chroot-script {{{
742 chrootscript() {
743   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
744      mount_target
745   fi
746   if [ -x "$MNTPOINT/bin/chroot-script" ] ; then
747      einfo "Executing chroot-script now"
748      chroot "$MNTPOINT" /bin/chroot-script
749      eend $?
750   else
751      eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
752      eend 1
753   fi
754 }
755 # }}}
756
757 # install booloader grub {{{
758 grub_install() {
759   if [ -z "$GRUB" -o -z "$GROOT" ] ; then
760      echo "Notice: \$GRUB or \$GROOT not defined, will not install grub therefor."
761   elif [ -n "$SELECTED_PARTITIONS" ] ; then # using sw-raid
762      for device in $SELECTED_PARTITIONS ; do
763         # TMPDEVICE=$(echo ${SELECTED_PARTITIONS} | awk '{print $1}')
764         # GRUB="$(grubdevice ${TMPDEVICE})"
765         # GRUB="$(grubdevice ${TMPDEVICE%%[0-9]})"
766         # GRUB=$(grubdevice $device)
767         GRUB="$(grubdevice ${device%%[0-9]})"
768         einfo "Installing grub on ${GRUB}:"
769         [ -x /usr/sbin/grub-install ] && GRUBINSTALL="/usr/sbin/grub-install --no-floppy" || GRUBINSTALL="/sbin/grub-install --no-floppy"
770         $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
771         eend $?
772      done
773   else
774      einfo "Installing grub on ${GRUB}:"
775      [ -x /usr/sbin/grub-install ] && GRUBINSTALL="/usr/sbin/grub-install --no-floppy" || GRUBINSTALL="/sbin/grub-install --no-floppy"
776      $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
777      eend $?
778   fi
779 }
780 # }}}
781
782 # unmount $MNTPOINRT {{{
783 umount_chroot() {
784   if [ -n "$ISODIR" ] ; then
785      if grep -q "$ISODIR" /proc/mounts ; then
786         einfo "Unmount $MNTPOINT/$ISODIR"
787         umount "$MNTPOINT/$ISODIR"
788         eend $?
789      fi
790   fi
791   if grep -q "$MNTPOINT" /proc/mounts ; then
792      if [ -n "$PARTITION" ] ; then
793         einfo "Unmount $MNTPOINT"
794         umount $MNTPOINT
795         eend $?
796      fi
797   fi
798 }
799 # }}}
800
801 # execute filesystem check {{{
802 fscktool() {
803   if [ "$FSCK" = 'yes' ] ; then
804      [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
805      einfo "Checking filesystem on $TARGET using $FSCKTOOL"
806      $FSCKTOOL $TARGET
807      eend $?
808   fi
809 }
810 # }}}
811
812 # now execute all the functions {{{
813 for i in mkfs tunefs mount_target debootstrap_system preparechroot \
814          chrootscript grub_install umount_chroot fscktool ; do
815     if stage "${i}" ; then
816        $i && ( stage "${i}" done && rm -f "${STAGES}/${i}" ) || bailout 2 "i"
817     fi
818 done
819 # }}}
820
821 # finalize {{{
822 einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
823 einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
824
825 # Remove temporary mountpoint again
826 if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
827    einfo "Removing directory ${MNTPOINT}" ; rmdir "$MNTPOINT" ; eend $?
828 fi
829 # }}}
830
831 # end dialog of autoinstallation {{{
832 if [ -n "$AUTOINSTALL" ] ; then
833    dialog --title "$PN" --msgbox \
834           "Finished execution of ${PN}. Enjoy your Debian system." 0 0
835 else
836    einfo "Finished execution of ${PN}. Enjoy your Debian system." ; eend 0
837 fi
838 # }}}
839
840 ## END OF FILE #################################################################
841 # vim: ai tw=100 expandtab foldmethod=marker shiftwidth=3